;file che comanda in uscita un solo DAC mcp4822
;uso RB0 come CS (attivo basso) e RB2 come ldap (anch'esso basso)
;si dovrebbe leggere in uscita la tensione massima su entrambi i dac (pin 6 e 8)

	LIST P=18F452, F=INHX32	;directive to define processor and file format
	#include <P18F452.INC>	;processor specific variable definitions
	#include <SPIMPol.inc>
	#include <UARTInt.inc>
	#include <ADCPol.inc>
;******************************************************************************
;Configuration bits
;Microchip has changed the format for defining the configuration bits, please 
;see the .inc file for futher details on notation.  Below are a few examples.



;   Oscillator Selection:
    CONFIG	OSC = XT,  WDT=OFF             ;XT

;******************************************************************************
;Variable definitions
; These variables are only needed if low priority interrupts are used. 
; More variables may be needed to store other special function registers used
; in the interrupt routines.
	mult_data UDATA 
	;dati per moltiplicazione per 9.8
		tmpH	RES	01
		TMP	RES	01
		TMPW	RES	01
		TMPSUB	RES	01	
		DTEMP	RES	01
		DTEMP2	RES	01
		DTEMP3	RES 01
	
	somma16_data UDATA 
		;dati per somma16 e diff16
		num1H 	RES 02
		#define num1L  	num1H+1
		num2H	RES	02
		#define	num2L	num2H+1
		resH	RES	02
		#define	resL	resH+1

	#define w1250L 0xE2
	#define w1250H 0x04

	#define w3750L 0xA6
	#define w3750H 0x0E


	UDATA
	adcRSLThigh 	RES 01 ;valore in cui viene letto l'adc
	adcRSLThighOld	RES 01 ;valore temporaneo in cui viene messo il vecchio valore letto dall'adc
	
	channelARead	RES 01 ;differenza tra i due segnali del canale A della leva
	channelBRead	RES	01 ;differenza tra i due segnali del canale B della leva	
	diffTemp		RES	01 ;variabile temporanea per la funzione di differenza
	

	TMP_CHKSUM		RES 01 ;variabile per il calcolo del checksum da mandare sulla seriale
	startByteMode	RES 01 ;variabile per il valore da trasmettere sulla seriale
	new_startByteMode	RES 01 ;variabile per il valore da trasmettere sulla seriale

	CtrlInterruptReceived		RES 01 ;bit 0:settato quando scatta timer 1
									   ;bit 1:settato da int0
									   ;bit 2:settato da timer0
									   ;bit 3:settato dall'automa che riceve i comandi dalla seriale quando ha un nuovo comando pronto
	
	TMP_DAC	RES	01
	ACTIVEDAC	RES	01 					;variabile di selezione del DAC e del canale del dac: 
										;bit 7-2 ignorati
										;bit 1 se 0 canale A se 1 canale B
										;bit 0 usa il primo chip dac se 1 usa il secondo chip dac
	DACOutH RES 02 						;uscita del DAC
	#define DACOutL DACOutH+1

	lastValueAReceived 			RES 01 			;variabili per i valori ricevuti dalla seriale
	lastValueBReceived			RES 01 

	fsmTemp 					RES 01 			;temporanea per ricezione comando
	fsmChk	 					RES 01 			;temporanea per checksum
	fsmState 					RES 01 			;stato dell'automa a stati finiti
	fsmManualAuto 				RES 01 			;ultima impostazione ricevuta dal pc
	fsmValueAReceived 			RES 01 			;valori ricevuti dalla seriale
	fsmValueBReceived 			RES 01 
	fsmManualAutoComplete 		RES 01 			;ultima impostazione ricevuta dal pc
	fsmValueAReceivedComplete 	RES 01 			;valori ricevuti dalla seriale
	fsmValueBReceivedComplete 	RES 01 
	

	;Dati necessari per uso interrupt e uart
	UARTTstRAM  UDATA 
	ISR_STAT    RES 02					;For saving STATUS value
	#define     ISR_BSR	ISR_STAT+1		;For saving BSR

	UARTTstShr	 UDATA_ACS
	ISR_W	    	RES 01	            ;For Saving W reg. value
	
		


;******************************************************************************
;Reset vector
; This code will start executing when a reset occurs.

RESET_VECTOR	CODE	0x0000

		goto	Main				;go to start of main code

INTHserv        CODE    0x08	    ;High priority vector
        goto    ISR

ISR_CODE CODE
ISR:
    movwf	ISR_W		        	;save Wreg in ISR_W, If NOP is used above
	movff	STATUS, ISR_STAT        ;put STATUSreg (swapped) into ISR_STAT
	movff   BSR, ISR_BSR            ;Save BSR

;call the interrupt function
    call		timer1ISR           ;service routine per timer1
    call		int0ISR           	;service routine per int0
    call		timer0ISR           ;service routine per timer0
	call	    UARTIntISR	        ;Call general purpose RTC interrupt service routine
;restore context

    movff   ISR_BSR,  BSR           ;Restore BSR
    movf    ISR_W,W
    movff   ISR_STAT, STATUS        ;Restore status
	retfie

;********************************************************************************************
;********************************************************************************************
;**   Timer1ISR: risponde all'interrupt di timer1
;********************************************************************************************
;********************************************************************************************	
	timer1ISR:
	btfss   PIR1,TMR1IF       ;Check for TimerInterrupt
		;se 0 non c' interrupt del timer, esco
	bra endISR
	bcf T1CON,0 ;disabilita il timer
	bcf PIR1,TMR1IF ;cancella l'interrupt ricevuto
	bsf CtrlInterruptReceived,0
	endISR:
	return

;********************************************************************************************
;********************************************************************************************
;**   int0ISR : risponde all'interrupt int0
;********************************************************************************************
;********************************************************************************************	
	int0ISR:
	btfss   INTCON,INT0IF       ;Check for int0
	bra endISR_INT0 ;se 0 non c' interrupt, esco
		bcf INTCON,INT0IE
		bcf INTCON,INT0IF
		bsf CtrlInterruptReceived,1
		bsf INTCON,INT0IE
	endISR_INT0:
	return

;********************************************************************************************
;********************************************************************************************
;**   timer0ISR : risponde all'interrupt di timer0
;********************************************************************************************
;********************************************************************************************	
	timer0ISR:
	btfss   INTCON,TMR0IF       ;Check for TimerInterrupt
		;se 0 non c' interrupt del timer, esco
	bra endtimer0ISR
	bcf T0CON,7 ;disabilita il timer
	bcf INTCON,TMR0IF  ;cancello l'interrupt ricevuto
	bsf CtrlInterruptReceived,2
	endtimer0ISR:
	return
	
;********************************************************************************************
;********************************************************************************************
;**   Main: risponde all'interrupt di timer1
;********************************************************************************************
;********************************************************************************************	
MAIN_CODE CODE
Main:

	movlw B'00011111' ;primi 5 bit input
	movwf TRISA

	clrf PORTB
	movlw B'00000001';b0 in input in quanto e' il pulsante collegato ad int0
	movwf TRISB
	
	movlw   B'10010000' ;sulla portC c' la seriale (UART) e la SPI                         
    movwf   TRISC                           
                   
	movlw B'00000000'
	movwf TRISD
	
	;Settaggio porta uart
	;che  sui pin RC6(TX) e RC7(RX)
	call    UARTIntInit

	;ADC init	                         
	mADCPolInit ADCPORTCONFIG0 ;inizializzazione: imposta la porta A come 
								;ingresso analogico sul AN0, AN1, AN2, AN3
	
	;SPI INIT
    call    SPIMPolInit                     ;Initialise SSP MOdule                                                
    mSPIMPolSetClockIdleState Lo            ;
    mSPIMPolSetTransmitOnClockEdge ActiveToIdle;
    mSPIMPolSetSampleAtDataOut Ends         ;Questo dovrebbe essere inutile
	
	;modalita' di partenza: manuale
    movlw 0xF0  ;F0=modo manuale, F1=automatico
    movwf startByteMode
    movwf new_startByteMode

    movlw 0x80  ;metto 128 nelle variabili che indicano gli utlimi valori letti dalla seriale
				;cosi' "sta ferrma" nel momento in cui passo alla modalita' automatica senza ricevere nulla...
    movwf lastValueAReceived
    movwf lastValueBReceived

	clrf fsmState ;l'automa a stati finiti deve partire dallo stato 0
    clrf CtrlInterruptReceived
	;imposto timer 1
	movlw B'00000000' ;8 bit op|-|prescaler 00|0 timer osc disabled|0|0 clock interno|stop
    movwf T1CON
	;imposto timer 0
	movlw B'00000100' ;timer off|16 bit|su clock|0|prescaler on|prescaler 010 (8)
	;tempo timer= 1us*8*FFFFh ~ 0.52 sec
	movwf T0CON
	
	bcf PORTB,1
	bcf PORTB,2
    bsf PIE1,TMR1IE ;abilito l'interrupt del timer 1
    bsf INTCON,TMR0IE ;abilito l'interrupt del timer 0
    bsf INTCON,INT0IE ;abilito l'interrupt di int 0

    bsf INTCON,GIE ;abilito l'interrupt generale
    bsf INTCON,PEIE ;abilito l'interrupt generale delle periferiche

	
	;uscita preliminare che mantiene ferma la carrozzina (di sicurezza)
	movlw 0x80
	bcf ACTIVEDAC,0 ;DAC1
	call dacDifferentialOut
		
	movlw 0x80
	bsf ACTIVEDAC,0 ;DAC2
	call dacDifferentialOut		
	call outLDAP


	
loop:
	call startTimer1 ;faccio partire il primo timer
	btg PORTB,2
	;si occupa di controllare la variabile CtrlInterruptReceived per controllare se  scattato il timer0
	;che indica se  scaduto il tempo di lavoro automatico e int0: cambio modalit di funzionamento da parte dell'utente
	;imposta il valore di startByteMode
	call controlloIntRxCicloPrecedente
	

	mADCPolChannelSelect .0  	;ADC channel 0 is selected.
	call adcGet
	movff adcRSLThigh, adcRSLThighOld
	

	mADCPolChannelSelect .1  	;ADC channel 1 is selected.
	call adcGet
	call diffAdc				;calcola la differenza tra high e low, old e new e salva in W
	movwf channelARead


	mADCPolChannelSelect .2  	;ADC channel 2 is selected.
	call adcGet
	movff adcRSLThigh, adcRSLThighOld


	mADCPolChannelSelect .3  	;ADC channel 3 is selected.
	call adcGet
	call diffAdc 				;calcola la differenza tra high e low, old e new e salva in W
	movwf channelBRead

	;spedisco al pc i valori letti
	call outSerial


	;bcf startByteMode, 0
	;controllo se il comando e' manuale o automatico
	btfss startByteMode,0
	bra manualMode
	bra automaticMode

	manualMode:
		movf channelARead, 0
		bcf ACTIVEDAC,0 ;DAC1
		call dacDifferentialOut
		
		movf channelBRead, 0
		bsf ACTIVEDAC,0 ;DAC2
		call dacDifferentialOut		
		call outLDAP

		bra endLoop
	
	automaticMode:		
		movf lastValueAReceived, 0
		bcf ACTIVEDAC,0 ;DAC1
		call dacDifferentialOut
		
		movf lastValueBReceived, 0
		bsf ACTIVEDAC,0 ;DAC2
		call dacDifferentialOut		
		call outLDAP	

	endLoop:	
	;attesa timer 1 per avere un controllo a 50hz, cioe' un ciclo di 0.02sec 
	call waitTimer1SerialReceive
goto loop


;********************************************************************************************
;********************************************************************************************
;**   controlloIntRxCicloPrecedente:
;********************************************************************************************
;********************************************************************************************
	controlloIntRxCicloPrecedente:
		bcf INTCON, GIE
		bcf INTCON, INT0IE
		bcf INTCON, TMR0IE
		bcf PIE1,TMR1IE
		bsf INTCON, GIE
		movff startByteMode,new_startByteMode ;copio la modalit
		;all'inizio controllo in che modalit ero
		btfss startByteMode,0
			goto prevManual
		

;bit 0:settato quando scatta timer 1
;bit 1:settato da int0
;bit 2:settato da timer0
;bit 3:settato dall'automa che riceve i comandi dalla seriale quando ha un nuovo comando pronto

		;prevAuto
		btfss CtrlInterruptReceived,2 ;controllo se  scaduto timer0
			goto tmr0nonScaduto
			;tmr0  scaduto, passo a modalit manuale (ignoro int0 e eventuali ricezioni)
			goto passaManuale
		tmr0nonScaduto:
			btfss CtrlInterruptReceived,1 ;controllo se c' stato int0
				goto int0nonRicevuto
			;int0  scattato, passo a modalit manuale (ignoro eventuali ricezioni)
			goto passaManuale
		int0nonRicevuto:
			btfss CtrlInterruptReceived,3 ;controllo se c' un comando ricevuto
				goto endCtrl
			; stato ricevuto un nuovo comando e n il timer n l'utente sono passati alla modalit manuale
			btfss fsmManualAuto,0 ;se viene comandato il passaggio alla modalit manuale dal pc
				goto passaManuale
			movff fsmManualAutoComplete,new_startByteMode ;copio la nuova modalit da usare
			movff fsmValueAReceivedComplete,lastValueAReceived
			movff fsmValueBReceivedComplete,lastValueBReceived
		goto endCtrl


	passaManuale:
		bcf PORTB, 1
		bcf T0CON,7 ;stoppo il timer, tanto non serve pi
		bcf new_startByteMode,0 ;imposto modalit manuale
		movlw 0x80 ;carico i valori di sicurezza nei valori da porre in uscita
		movwf lastValueAReceived
		movwf lastValueBReceived
		goto endCtrl


	prevManual:
		
		btfss CtrlInterruptReceived,1 ;controllo se c' stato int0, che  l'unico modo di ripassare in automatico
			goto endCtrl
		bsf new_startByteMode,0 ;imposto modalit automatica
		movlw 0x80 ;carico i valori di sicurezza nei valori da porre in uscita
		movwf lastValueAReceived
		movwf lastValueBReceived
		;nota bene: non controllare qui se l'ultimo comando ricevuto era di impostare la modalit manuale, 
		;altrimenti non si trasmetter al pc la "volont" di passare alla modalit automatica
		call startTimer0 ;ora faccio partire il timer0, in modo che controllo il tempo che resta in modalit automatica 
						;senza ricevere comandi (corretti)
		bsf PORTB, 1
		
			
	endCtrl:
		movff new_startByteMode,startByteMode ;imposto la nuova modalit di funzionamento
		bcf CtrlInterruptReceived,1 ;pulisco
		bcf CtrlInterruptReceived,2 
		bcf CtrlInterruptReceived,3 
		bcf INTCON, GIE
		bsf INTCON, INT0IE
		bsf INTCON, TMR0IE
		bsf PIE1,TMR1IE
		bsf INTCON, GIE
		nop
		nop
		nop
		nop
		nop
	return

;********************************************************************************************
;********************************************************************************************
;**   startTimer1: imposta il timer 1 in modo da conteggiare 0.02 secondi, tempo fissato per il
;**					ciclo di controllo (50hz)
;********************************************************************************************
;********************************************************************************************
	startTimer1:
		;valore per 20ms ottenuto sperimentalmente
		movlw 0xB2
		movwf TMR1H ;inizializzo
		movlw 0x32
		movwf TMR1L ;inizializzo
		bsf T1CON,0 ;abilita il timer
	return 

;********************************************************************************************
;********************************************************************************************
;**   startTimer0: fa partire timer0 ()
;********************************************************************************************
;********************************************************************************************
	startTimer0:
		bcf T0CON,7 ;disabilita il timer nel caso stia ancora girando
		clrf TMR0H ;inizializzo
		clrf TMR0L ;inizializzo
		bsf T0CON,7 ;abilita il timer
	return 

;********************************************************************************************
;********************************************************************************************
;**   fsmReceiver: riceve in w l'ultimo carattere letto dalla seriale e esegue
;**			i controlli necessari. Imposta i valori di lastValueAReceived e lastValueBReceived
;**			quando riceve un comando completo e corretto
;********************************************************************************************
;********************************************************************************************
	fsmReceiver:
		movwf	fsmTemp
		movf fsmState,0 ;sposto lo stato in w
		bz state0
		decf WREG,0 ;decremento w, se 0 lo stato e' 1
		bz state1
		decf WREG,0 ;decremento w, se 0 lo stato e' 1
		bz state2
		decf WREG,0 ;decremento w, se 0 lo stato e' 1
		bz state3
		
		;caso in cui non dovrebbe mai cadere, in quanto fsmState assume valori da 0 a 3,
		;programmazione difensiva: faccio ripartire l'automa
		clrf fsmState
		bra state0
	
	state0:
		;bcf PORTB,2
		movff fsmTemp,fsmChk ;inizio ad impostare il check sum
		movff fsmTemp,fsmManualAuto ;memorizzo la nuova modalit da usare (comunicata dal pc)

		;nello stato 0 devo attendere che arrivi il 0xF0 o 0xF1
		movlw 0xFE ;non considero l'ultimo bit
		andwf fsmTemp,1 ;facendo and in W ci deve essere 0xF0, se ho ricevuto il byte corretto
		movlw 0xF0 ;
		subwf fsmTemp,0
		bnz state0notChanged ;se la sottrazione non fa 0, allora non ho ricevuto F0 o F1, quindi non cambio stato
			;caso corretto
			incf	fsmState ;se ho ricevuto il primo byte corretto, cambio lo stato dell'automa
		
		state0notChanged:
		bra endfsmRoutine


	state1:
		movf fsmTemp,0 ;ricopio il valore ricevuto su w
		movwf fsmValueAReceived ;e sulla variabile di controllo corrispondente
		addwf fsmChk,1 ;aggiorno il checksum
		incf	fsmState ;cambio lo stato dell'automa
		
		bra endfsmRoutine



	state2:
		movf fsmTemp,0 ;ricopio il valore ricevuto su w
		movwf fsmValueBReceived ;e sulla variabile di controllo corrispondente
		addwf fsmChk,1 ;aggiorno il checksum
		incf	fsmState ;cambio lo stato dell'automa
			
		bra endfsmRoutine


	state3:
		movf fsmTemp,0 ;ricopio il valore ricevuto (checksum) su w
		subwf fsmChk,0 ;sottraggo il checksum calcolato
		bnz chkError ;se il checksum non e' corretto devo scartare il comando

		movff fsmManualAuto,fsmManualAutoComplete
		movff fsmValueAReceived,fsmValueAReceivedComplete
		movff fsmValueBReceived,fsmValueBReceivedComplete

		;se il checksum e' corretto segnalo che l'automa  arrivato a completare il suo ciclo
		bsf CtrlInterruptReceived,3
		;bsf PORTB,2
		call startTimer0 ;faccio ripartire il timer, perch ho ricevuto correttamente un nuovo comando
		clrf fsmState
		goto endfsmRoutine
		
		chkError:
		clrf fsmState
		
	endfsmRoutine:
		return


;********************************************************************************************
;********************************************************************************************
;**   waitTimer1: attende che scada timer 1 per continuare il ciclo di controllo, nel frattempo
;** 	riceve i caratteri dalla seriale
;********************************************************************************************
;********************************************************************************************
	waitTimer1SerialReceive:
		btfss   CtrlInterruptReceived,0 
		bra serialGet
		bra endwait
	
	serialGet:
        movf    vUARTIntRxBufDataCnt,0
        bz     waitTimer1SerialReceive;se non ci sono dati da ricevere torno da capo
		
		call UARTIntGetCh ;prelevo il carattere dalla seriale
		call fsmReceiver  ;e faccio lavorare l'automa a stati finiti di ricezione caratteri
				;che nel caso giunge a termine imposta i valori da mandare in uscita 
				; e la modalita' di funzionamento (automatico/manuale)

		bra waitTimer1SerialReceive
	
	;tempo del timer scaduto (fine del loop di controllo)
	endwait:
		bcf CtrlInterruptReceived,0 ;pulisco il bit di controllo
		return


;********************************************************************************************
;********************************************************************************************
;**   outSerial: pone in uscita sulla seriale i valori letti con gli adc (se buffer tx vuoto, altrimenti esce)
;**			formato trama: 0xF?|channelA|channelB|checkSum
;**			primo byte 0xF? dove ? puo' essere 0 per comunicare al pc che il comando e' attualmente manuale
;**					oppure 1 per comunicare che e' automatico
;********************************************************************************************
;********************************************************************************************
outSerial:
    movf    vUARTIntTxBufDataCnt,0
    bnz     endOutSerial ;se il buffer di tx non e' vuoto esco
	;(non dovrebbe mai accadere in quanto 4 byte a 9600 impiegano circa 4ms)

	;primo byte della trama, impostato nel ciclo di controllo
	movf startByteMode,0
	movwf TMP_CHKSUM ;primo valore per il checksum
	call UARTIntPutCh

	movf channelARead, 0
	addwf TMP_CHKSUM,1
	call UARTIntPutCh

	movf channelBRead, 0
	addwf TMP_CHKSUM,1
	call UARTIntPutCh

	movf TMP_CHKSUM,0
	call UARTIntPutCh
endOutSerial:
	return
;********************************************************************************************
;********************************************************************************************
;**   adcGet: si occupa di effettuare la lettura dei valori dall'ADC (che deve essere gi 
;** 		  stato selezionato. Restituisce il valore in adcRSLThigh
;********************************************************************************************
;********************************************************************************************
adcGet:
	nop
    call ADCPolAcquisitionTime  ;Before starting AD conversion a delay
                                ;of acquisition time is provided. 
                                ;This function provides this delay.
                                ;User enters the required delay with
    mADCPolStart                ;This starts AD conversion

	Check       mADCPolIsBusy   ;Tests whether AD conversion is over.
                                ;If over WREG contains 0, otherwise 1
            	btfsc  WREG,0    
            	goto Check        
     
    mADCPolReadHigh             ;High byte of ADC result is available in W reg
    movwf adcRSLThigh			;sposto il byte alto nella variabile adcRSLThigh
    mADCPolReadLow				;il byte basso lo leggo ma lo perdo, tanto non lo uso
	return

;********************************************************************************************
;********************************************************************************************
;**   diffAdc: differenza tra valori 8 bit letti dall'adc e controlli per avere sempre 
;**         valori compresi tra 0 e 255. Esegue (adcRSLThighOld - adcRSLThigh)+128, pone
;**			il risultato in w
;********************************************************************************************
;********************************************************************************************
diffAdc:
	;deve eseguire la differenza adcRSLThighOld - adcRSLThigh
	movlw D'128'
	movwf diffTemp
	movf adcRSLThigh, 0
	cpfslt adcRSLThighOld ;skip se Old>W (la differenza  positiva)
	goto diffPos	
	
	;se la differenza  negativa, faccio new-old e sottraggo 128
		movf adcRSLThighOld, 0		
		subwf adcRSLThigh, 0 ;sottrazione New-Old (positiva)
		subwf diffTemp, 0 ;sottrae 128 al risultato della sottrazione e lo mette in W
		bov endDiff ;salta se non c' overflow
		movlw D'0' ;se c' overflow i valori erano fuori range e ho 0
		goto endDiff

diffPos
	;differenza positiva
	subwf adcRSLThighOld, 0 ;sottrazione Old-New (positiva)
	addwf diffTemp, 0 ;aggiunge 128 al risultato della sottrazione e lo mette in W
	; se genera overflow vuol dire che i valori letti erano fuori range, cio differenza>2.5v, cio 128
	bnov endDiff ;salta se non c' overflow
	movlw D'255' ;se c' overflow imposto il valore corretto
	goto endDiff
	
	

	endDiff:
		return


;********************************************************************************************
;********************************************************************************************
;**   mult98: moltiplica W per 9.8 e restituisce in resH e resL. Basato su shift a dx e sx
;********************************************************************************************
;********************************************************************************************
mult98 CODE
mult98:
	bcf STATUS,C
	clrf tmpH

	movwf TMP
	movwf TMPW
	rlcf TMP
	rlcf tmpH
	movff tmpH, resH ;moltiplicazione per 2 in resH
	movff TMP, resL  ;moltiplicazione per 2 in resL
	rlcf TMP
	rlcf tmpH
	rlcf TMP
	rlcf tmpH ;moltiplicazione per 8 in TMP e tmpH
	movf TMP, 0
	addwf resL, 1 ;somma al valore gi moltiplicato per 2 (parte bassa)
	movf tmpH, 0 ;somma la parte alta aggiungendo al carry
	addwfc resH, 1
		
	;ora sottraiamo circa 0.2*W
	bcf STATUS,C
	rrcf TMPW ;1/2
	bcf STATUS,C
	rrcf TMPW ;1/4
	bcf STATUS,C
	rrcf TMPW ;1/8 serve
	movff TMPW, TMPSUB
	bcf STATUS,C
	rrcf TMPW ;1/16 serve
	movf TMPW, 0
	addwf TMPSUB, 1
	bcf STATUS,C
	rrcf TMPW ;1/32
	bcf STATUS,C
	rrcf TMPW ;1/64 serve
	movf TMPW, 0
	addwf TMPSUB, 1
	bcf STATUS,C
	rrcf TMPW ;	1/128 serve
	movf TMPW, 0
	addwf TMPSUB, 1 ;in TMPSUB risultato della moltiplicazione per 0.2
	
	;differenza a 16 bit tra resH,resL e 00,TMPSUB
	movff resH,num1H
	movff resL,num1L
	clrf num2H
	movff TMPSUB,num2L
	call diff16
	return

Somma16 CODE
;********************************************************************************************
;********************************************************************************************
;**   somma16: somma due numeri a 16 bit, resH,resL = num1H,num1L + num2H,num2L
;********************************************************************************************
;********************************************************************************************
somma16:
	movf num1L, 0
	addwf num2L, 0
	movwf resL
	movf num1H, 0
	addwfc num2H, 0
	movwf resH
	return

;********************************************************************************************
;********************************************************************************************
;**   diff16: differenza tra due numeri a 16 bit, resH,resL = num1H,num1L - num2H,num2L
;********************************************************************************************
;********************************************************************************************
diff16:
	call complemento
	call somma16
	return
	
;********************************************************************************************
;********************************************************************************************
;**   complemento: complemento a due di num2H,num2L
;********************************************************************************************
;********************************************************************************************
complemento:
	comf num2L ;complemento a 1 entrambi i numeri
	comf num2H 
	incf num2L
	bnc avanti
	incf num2H
avanti:
	return	


;********************************************************************************************
;********************************************************************************************
;**   DacOut: prende i valori di dacOutH e dacOutL e li mette in uscita sul chip selezionato
;**   dal bit 0 di ACTIVEDAC e sul canale selezionato dal bit 1 di ACTIVEDAC
;********************************************************************************************
;********************************************************************************************
OUTDACCODE CODE
DacOut:
	nop
	nop
                      
	;se ACTIVEDAC  1 attivo il dac1 e viceversa
    btfss ACTIVEDAC,0 
	bcf     PORTD,0 ;Select the DAC1 by making RD0 Low
    btfsc ACTIVEDAC,0 
	bcf     PORTD,1 ;Select the DAC2 by making RD1 Low
	
	nop
	nop

	movlw 0x0F
	andwf DACOutH ;and tra DACOutH e 0F, con risultato in DACOutH
	
		
	;DACA, gain 2,attivo,b11-b8
    movlw   B'00010000'
    btfsc 	ACTIVEDAC,1	;sceglie tra A e B
	bsf		WREG,7 		;se deve scegliere b pone a 1 il bit 7

	iorwf 	DACOutH,0 ;or
	
    call    SPIMPolPut                      ;
	call 	SPIMPolIsDataReady            ;bloccante finch non finisce tx

	
	movf DACOutL, 0

    call SPIMPolPut                      ;
	call SPIMPolIsDataReady            ;bloccante finch non finisce tx
	nop
	nop
	;se ACTIVEDAC  1 disattivo il dac1 e viceversa
    btfss ACTIVEDAC,0 
	bsf     PORTD,0 ;unselect the DAC1 by making RD0 High
    btfsc ACTIVEDAC,0 
	bsf     PORTD,1 ;unselect the DAC2 by making RD1 High
	nop
	nop
return


;********************************************************************************************
;********************************************************************************************
;**   outLDAP: abbassa per un certo tempo (???) il comando LDAP
;********************************************************************************************
;********************************************************************************************
OUTDACLCODE CODE
outLDAP:
    bcf     PORTD,2                         ;ldap basso, abilito l'uscita

	nop
	nop

    bsf     PORTD,2                         ;ldap alto, non abilitato

	nop
	nop
return



;********************************************************************************************
;********************************************************************************************
;**   dacDifferentialOut: moltiplica w * 9.8, pone in uscita su due dac dello stesso chip
;**   3750-val e 1250+val
;********************************************************************************************
;********************************************************************************************
dacDifferentialOut:
		call mult98 ;moltiplica per 9.8
	
		movlw w1250L
		movwf num1L

		movlw w1250H
		movwf num1H

		movff resH, num2H
		movff resL, num2L

		call somma16

		movff resH, DACOutH
		movff resL, DACOutL		
	
		bcf ACTIVEDAC,1 ;DACx, VOut_A
		call DacOut


		movlw w3750L
		movwf num1L

		movlw w3750H
		movwf num1H

		call diff16 ;il secondo numero  gi in num2H,L

		movff resH, DACOutH
		movff resL, DACOutL	

		bsf ACTIVEDAC,1 ;DACx, VOut_B
		call DacOut

		return

END
